//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Demo1.h"
#include "Unit1.h"
#include "Unit2.h"
#include "repere_xfig.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "OpenGLPanel"
#pragma link "CSPIN"
#pragma resource "*.dfm"

#define NB_ITEM_RENDU 2
ComboBoxRendu listeRendu[NB_ITEM_RENDU] =
        {
                {"fil de fer",WIREFRAME},
                {"plein",SOLID}
        };

#define NB_ITEM_RESOLUTION 3
ComboBoxResolution listeMethode[NB_ITEM_RESOLUTION] =
        {
                {"SIVIA pile",M_PILE},
                {"SIVIA file",M_FILE},
                {"SIVIA Automatique",M_AUTO}
        };

#define NB_ITEM_CAMERA 2
ComboBoxChoixCamera listeCamera[NB_ITEM_CAMERA] =
        {
                {"polaire",C_POLAIRE},
                {"libre",C_LIBRE}
        };

#define NB_ITEM_COUPURE 3
ComboBoxChoixCoupure listeCoupure[NB_ITEM_COUPURE] =
        {
                {"Auncun",C_AUCUNE},
                {"Trapze",C_TRAPEZE},
                {"Triangle",C_TRIANGLE}
        };



TForm1 *Form1;

//pointeur permettant de lancer le thread de calcul
CalculPave *CalculPaveThread=NULL;

//pointeur permettant de lancer le thread d'affichage
Affichage *MyThread;

float zoom=1.0;

#include "Echantillon.h"
Echantillons _echantillon;

#include "Probleme.h"
Probleme probleme;




void initCoupure()
{
        char temp[255];
        float valAlpha,valL;

        Form1->lCoupure->GetTextBuf(temp,sizeof(temp)-1);
        valL = atof(temp);

        Form1->alphaCoupe->GetTextBuf(temp,sizeof(temp)-1);
        valAlpha = atof(temp);


        if(valL>2)
                valL = 2;

        if(valL<0)
                valL = 0;

        if(valAlpha>1)
                valAlpha = 1;

        if(valAlpha<0)
                valAlpha = 0;


        Form1->coupure.type = (TYPE_COUPURE) Form1->ComboBoxTypeCoupure->Items->Objects[Form1->ComboBoxTypeCoupure->ItemIndex];
        switch(Form1->coupure.type)
        {
                case C_AUCUNE:
                        Form1->coupure.l = 0.0;
                        Form1->coupure.alpha = 0.0;
                break;

                case C_TRAPEZE:
                        Form1->coupure.l = valL;
                        Form1->coupure.alpha = valAlpha;
                break;

                case C_TRIANGLE:
                        Form1->coupure.l = 0.0;
                        Form1->coupure.alpha = valAlpha;
                break;
        }

        sprintf(temp,"%f",Form1->coupure.l);
        Form1->lCoupure->Text=temp;

        sprintf(temp,"%f",Form1->coupure.alpha);
        Form1->alphaCoupe->Text=temp;
}


void saveXfig(char* nom)
{
        char tmp[255];

        strcpy(tmp,nom);
        strcat(tmp,".fig");

        repere  R(tmp,CalculPaveThread->boxInit[1].GetInf(),CalculPaveThread->boxInit[1].GetSup(),
                        CalculPaveThread->boxInit[2].GetInf(),CalculPaveThread->boxInit[2].GetSup());

        unsigned int i;
        pave3d* pave;
        box P(2,true);

        for(i=0;i<CalculPaveThread->ListePaveRouge.size();i++)
        {
                pave = CalculPaveThread->ListePaveRouge.at(i);
                P[1] = pave->X;
                P[2] = pave->Y;
                R.DrawBox(P,XFIG_RED,1,2);
        }
        for(i=0;i<CalculPaveThread->ListePaveVert.size();i++)
        {
                pave = CalculPaveThread->ListePaveVert.at(i);
                P[1] = pave->X;
                P[2] = pave->Y;
                R.DrawBox(P,XFIG_YELLOW,1,2);
        }

        for(i=0;i<CalculPaveThread->ListePaveBleu.size();i++)
        {
                pave = CalculPaveThread->ListePaveBleu.at(i);
                P[1] = pave->X;
                P[2] = pave->Y;
                R.DrawBox(P,XFIG_BLUE,1,2);
        }
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
 initCamera();

 pause = false;

 MyThread=new Affichage(False);

 initDialog();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OpenGLPanel1Init(TObject *Sender)
{
   	glViewport(0,0,(GLsizei)OpenGLPanel1->Width,(GLsizei)OpenGLPanel1->Height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
        if ( OpenGLPanel1->Height==0)
     	        gluPerspective(45, (GLdouble)OpenGLPanel1->Width, 1.0, 2000.0);
        else
                gluPerspective(45, (GLdouble)OpenGLPanel1->Width/
                           (GLdouble)OpenGLPanel1->Height,1.0, 2000.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glEnable(GL_DEPTH_TEST);
        glClearColor(0.5,0.5,0.5,0.0);

        GLfloat LightAmbient[]=		{ 0.5f, 0.5f, 0.5f, 1.0f };
        GLfloat LightDiffuse[]=		{ 1.0f, 1.0f, 1.0f, 1.0f };
        GLfloat LightPosition[]=	{ 0.0f, 20.0f, 10.0f, 0.0f };

        glEnable(GL_LIGHTING);

        glLightfv(GL_LIGHT1, GL_AMBIENT, LightAmbient);		// Setup The Ambient Light
	glLightfv(GL_LIGHT1, GL_DIFFUSE, LightDiffuse);		// Setup The Diffuse Light
	glLightfv(GL_LIGHT1, GL_POSITION,LightPosition);	// Position The Light
	glEnable(GL_LIGHT1);     				// Enable Light One

        glBlendFunc(GL_SRC_ALPHA,GL_ONE);

        glEnable(GL_COLOR_MATERIAL);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OpenGLPanel1Resize(TObject *Sender)
{
 glViewport(0,0,(GLsizei)OpenGLPanel1->Width,(GLsizei)OpenGLPanel1->Height);
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity();
 if ( OpenGLPanel1->Height==0)
    gluPerspective(45, (GLdouble)OpenGLPanel1->Width, 1.0, 2000.0);
 else
    gluPerspective(45, (GLdouble)OpenGLPanel1->Width/
                           (GLdouble)OpenGLPanel1->Height,1.0, 2000.0);
 glMatrixMode(GL_MODELVIEW);
 glLoadIdentity();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OpenGLPanel1Paint(TObject *Sender)
{
 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
 glPushMatrix();

 GLfloat LightPosition[4];

 Camera* cam;
 if( camera == C_LIBRE )
 {
    cam = cameraLibre;
 }
 else
 {
    cam = cameraPolaire;
 }

 glDisable(GL_BLEND);
 glScalef(zoom,1,1);
 glScalef(1,zoom,1);

 gluLookAt(cam->pos.x,cam->pos.y,cam->pos.z,
                cam->targ.x,cam->targ.y,cam->targ.z,
                0.0,1.0,0.0);

 //dessine le repere
 float taille = 2;

 glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT);
 glColor3f(1.0,0.0,0.0);
 glColorMaterial(GL_FRONT_AND_BACK, GL_DIFFUSE);
 glColor3f(1.0,0.0,0.0);
 glColorMaterial(GL_FRONT_AND_BACK, GL_SPECULAR);
 glColor3f(1.0,0.0,0.0);

 glBegin(GL_LINES);
        glVertex3f(0.0,0.0,0.0);
        glVertex3f(taille,0.0,0.0);
 glEnd();

 glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT);
 glColor3f(0.0,1.0,0.0);
 glColorMaterial(GL_FRONT_AND_BACK, GL_DIFFUSE);
 glColor3f(0.0,1.0,0.0);
 glColorMaterial(GL_FRONT_AND_BACK, GL_SPECULAR);
 glColor3f(0.0,1.0,0.0);

 glBegin(GL_LINES);
        glVertex3f(0.0,0.0,0.0);
        glVertex3f(0.0,taille,0.0);
 glEnd();

 glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT);
 glColor3f(0.0,0.0,1.0);
 glColorMaterial(GL_FRONT_AND_BACK, GL_DIFFUSE);
 glColor3f(0.0,0.0,1.0);
 glColorMaterial(GL_FRONT_AND_BACK, GL_SPECULAR);
 glColor3f(0.0,0.0,1.0);

 glBegin(GL_LINES);
        glVertex3f(0.0,0.0,0.0);
        glVertex3f(0.0,0.0,taille);
 glEnd();


 unsigned int i;
 pave3d* pave;

 if(optionAffichage.affPavetRouge)
 {
        glDisable(GL_BLEND);
        if(renduRouge==WIREFRAME)
        {
                glDisable(GL_LIGHTING);
        }
        else
        {
                glEnable(GL_LIGHTING);
        }

        //dessine les paves rouges
        for(i=0;CalculPaveThread!=NULL && i<CalculPaveThread->ListePaveRouge.size();i++)
        {
                pave = CalculPaveThread->ListePaveRouge.at(i);
                pave->drawPave3d(renduRouge,1);
        }
 }

 if(optionAffichage.affPavetVert)
 {
        if(optionAffichage.transparence && renduVert!=WIREFRAME)
        {
                glEnable(GL_BLEND);
                glDisable(GL_LIGHTING);
        }
        else
        {
                glEnable(GL_LIGHTING);
                glDisable(GL_BLEND);
        }
        //dessine les paves vert
        for(i=0;CalculPaveThread!=NULL && i<CalculPaveThread->ListePaveVert.size();i++)
        {
                pave = CalculPaveThread->ListePaveVert.at(i);
                pave->drawPave3d(renduVert,0.5);
        }
 }

 if(optionAffichage.affPavetBleu)
 {
        if(optionAffichage.transparence && renduBleu!=WIREFRAME)
        {
                glEnable(GL_BLEND);
                glDisable(GL_LIGHTING);
        }
        else
        {
                glEnable(GL_LIGHTING);
                glDisable(GL_BLEND);
        }
        //dessine les paves bleu
        for(i=0;CalculPaveThread!=NULL && i<CalculPaveThread->ListePaveBleu.size();i++)
        {
                pave = CalculPaveThread->ListePaveBleu.at(i);
                pave->drawPave3d(renduBleu,0.1);
        }
 }

 glPopMatrix();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
 if (SaveDialog1->Execute())
 {
       OpenGLPanel1->SaveOpenGLPanelToFile(SaveDialog1->FileName);
       if(CalculPaveThread)
       {
                char tmp[255];
                sprintf(tmp,"%s",SaveDialog1->FileName);
                saveXfig(tmp);
       }
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
 if (PrintDialog1->Execute()) OpenGLPanel1->PrintOpenGLPanel();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBarRotO1Change(TObject *Sender)
{
  Camera *cam;

  float RotY=(float)TrackBarRotO1->Position;

  if( camera == C_LIBRE)
  {
    cam = cameraLibre;
  }
  else
  {
    cam = cameraPolaire;
  }

  cam->aglxz=RotY;
  cam->update_camera();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBarRotO2Change(TObject *Sender)
{
  Camera *cam;

  float RotZ=(float)TrackBarRotO2->Position;

  if( camera == C_LIBRE)
  {
    cam = cameraLibre;
  }
  else
  {
    cam = cameraPolaire;
  }

  cam->aglyz=RotZ;
  cam->update_camera();
}

//---------------------------------------------------------------------------



void __fastcall TForm1::ButtonStartClick(TObject *Sender)
{
    if(CalculPave::fin==true)
    {
            if(CalculPaveThread!=NULL)
            {
                CalculPaveThread->Terminate();
                delete CalculPaveThread;
                CalculPaveThread = NULL;
                CalculPave::fin = true;
            }
            CalculPaveThread=new CalculPave(False,methodeResolution);
    }
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonPauseClick(TObject *Sender)
{
     pause = (pause)?false:true;
     if(CalculPaveThread!=NULL)
     {
        switch(pause)
        {
           case true:
                CalculPaveThread->Suspend();
           break;
           case false:
                CalculPaveThread->Resume();
           break;
        }
     }
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

void __fastcall TForm1::updateText()
{
  char temp[255];
  sprintf(temp,"%d",CalculPave::nbPave);
  Form1->nbPavet->Text=temp;

  Form1->precision->GetTextBuf(temp,sizeof(temp)-1);
  CalculPave::precision = atof(temp);

  Form1->tpsMiseAjour->GetTextBuf(temp,sizeof(temp)-1);
  Affichage::dt = atoi(temp);

  Form1->PasCamera->GetTextBuf(temp,sizeof(temp)-1);
  if( camera == C_LIBRE)
  {
    cameraLibre->pas = atof(temp);
  }
  else
  {
    cameraPolaire->pas = atof(temp);
  }

  if(CalculPaveThread!=NULL)
  {
        sprintf(temp,"%d",CalculPaveThread->ListePaveRouge.size());
        Form1->nbPaveRouge->Text = temp;

        sprintf(temp,"%d",CalculPaveThread->ListePaveVert.size());
        Form1->nbPaveVert->Text = temp;

        sprintf(temp,"%d",CalculPaveThread->ListePaveBleu.size());
        Form1->nbPaveBleu->Text = temp;
  }
  else
  {
        sprintf(temp,"0");
        Form1->nbPaveRouge->Text = temp;

        sprintf(temp,"0");
        Form1->nbPaveVert->Text = temp;

        sprintf(temp,"0");
        Form1->nbPaveBleu->Text = temp;
  }
}


void __fastcall TForm1::initCamera()
{
 cameraPolaire = new CameraPolaire();
 cameraLibre = new Camera();

 cameraLibre->pos = Point3d(0,0,-10);
 cameraLibre->modele_inverse( Point3d(0,0,1) );//on regarde vers les Z positif
 cameraLibre->update_camera();

 cameraPolaire->pos = Point3d(0,0,-10);
 cameraPolaire->modele_inverse( Point3d(0,0,1) );//on regarde vers les Z positif
 cameraPolaire->update_camera();
}

void __fastcall TForm1::initDialog()
{
  char temp[255];

  sprintf(temp,"%d",CalculPave::nbPave);
  Form1->nbPavet->Text=temp;

  if(CalculPaveThread!=NULL)
  {
        sprintf(temp,"%d",CalculPaveThread->ListePaveRouge.size());
        Form1->nbPaveRouge->Text = temp;

        sprintf(temp,"%d",CalculPaveThread->ListePaveVert.size());
        Form1->nbPaveVert->Text = temp;

        sprintf(temp,"%d",CalculPaveThread->ListePaveBleu.size());
        Form1->nbPaveBleu->Text = temp;
  }
  else
  {
        sprintf(temp,"0");
        Form1->nbPaveRouge->Text = temp;

        sprintf(temp,"0");
        Form1->nbPaveVert->Text = temp;

        sprintf(temp,"0");
        Form1->nbPaveBleu->Text = temp;
  }

  sprintf(temp,"%f",CalculPave::precision);
  Form1->precision->Text=temp;

  sprintf(temp,"%d",Affichage::dt);
  Form1->tpsMiseAjour->Text=temp;

  sprintf(temp,"%d",Affichage::dt);
  Form1->tpsMiseAjour->Text=temp;

  Camera *cam;
  if( camera == C_LIBRE )
  {
    cam = cameraLibre;
  }
  else
  {
    cam = cameraPolaire;
  }

  TrackBarRotO1->Position = cam->aglxz;
  TrackBarRotO2->Position = cam->aglyz;

  sprintf(temp,"%f",cam->pas);
  Form1->PasCamera->Text=temp;


  int i;

  for(i=0;i<NB_ITEM_RENDU;i++)
  {
        ComboBoxRenduRouge->Items->AddObject(listeRendu[i].nom, (TObject *)(listeRendu[i].rendu));
        ComboBoxRenduVert->Items->AddObject(listeRendu[i].nom, (TObject *)(listeRendu[i].rendu));
        ComboBoxRenduBleu->Items->AddObject(listeRendu[i].nom, (TObject *)(listeRendu[i].rendu));
  }
  ComboBoxRenduRouge->ItemIndex = 0;
  ComboBoxRenduVert->ItemIndex = 0;
  ComboBoxRenduBleu->ItemIndex = 0;

  renduRouge = (TYPE_RENDU) ComboBoxRenduRouge->Items->Objects[ComboBoxRenduRouge->ItemIndex];
  renduVert = (TYPE_RENDU) ComboBoxRenduVert->Items->Objects[ComboBoxRenduVert->ItemIndex];
  renduBleu = (TYPE_RENDU) ComboBoxRenduBleu->Items->Objects[ComboBoxRenduBleu->ItemIndex];

  for(i=0;i<NB_ITEM_RESOLUTION;i++)
  {
        ComboBoxResolution->Items->AddObject(listeMethode[i].nom, (TObject *)(listeMethode[i].methodeResolution));
  }
  ComboBoxResolution->ItemIndex = 0;

  methodeResolution = (TYPE_RESOLUTION) ComboBoxResolution->Items->Objects[ComboBoxResolution->ItemIndex];


  for(i=0;i<NB_ITEM_COUPURE;i++)
  {
        ComboBoxTypeCoupure->Items->AddObject(listeCoupure[i].nom, (TObject *)(listeCoupure[i].coupure));
  }
  ComboBoxTypeCoupure->ItemIndex = 0;

  initCoupure();


  for(i=0;i<NB_ITEM_CAMERA;i++)
  {
        ComboBoxTypeCamera->Items->AddObject(listeCamera[i].nom, (TObject *)(listeCamera[i].camera));
  }
  ComboBoxTypeCamera->ItemIndex = 0;

  camera = (TYPE_CAMERA) ComboBoxTypeCamera->Items->Objects[ComboBoxTypeCamera->ItemIndex];


  optionAffichage.affPavetRouge = true;
  optionAffichage.affPavetVert = true;
  optionAffichage.affPavetBleu = true;
  optionAffichage.transparence = true;

  CheckBoxPRouge->Checked = true;
  CheckBoxPBleu->Checked = true;
  CheckBoxPVert->Checked = true;
  CheckBoxTrans->Checked = true;


  // paramtres fichier
  _echantillon.getNameFileEchantillon(temp);

  Form1->F_echantillons->Text = temp;

}

void __fastcall TForm1::nbPavetChange(TObject *Sender)
{
  updateText();
}
//---------------------------------------------------------------------------








void __fastcall TForm1::RadioButtonPolaireClick(TObject *Sender)
{
  TrackBarRotO1->Position = cameraPolaire->aglxz;
  TrackBarRotO2->Position = cameraPolaire->aglyz;

  char temp[255];
  sprintf(temp,"%f",cameraPolaire->pas);
  Form1->PasCamera->Text=temp;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButtonLibreClick(TObject *Sender)
{
  TrackBarRotO1->Position = cameraLibre->aglxz;
  TrackBarRotO2->Position = cameraLibre->aglyz;

  char temp[255];
  sprintf(temp,"%f",cameraLibre->pas);
  Form1->PasCamera->Text=temp;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::PasCameraChange(TObject *Sender)
{
  char temp[255];
  Form1->PasCamera->GetTextBuf(temp,sizeof(temp)-1);
  if( camera == C_LIBRE )
  {
    cameraLibre->pas = atof(temp);
  }
  else
  {
    cameraPolaire->pas = atof(temp);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonAvanceClick(TObject *Sender)
{
  zoom +=.1;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ButtonReculeClick(TObject *Sender)
{
  zoom -=.1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonTransLeftClick(TObject *Sender)
{
   if( camera == C_LIBRE)
  {
    cameraLibre->translation(DROITE,cameraLibre->pas);
  }
  else
  {
    cameraPolaire->translation(DROITE,cameraPolaire->pas);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonTransRightClick(TObject *Sender)
{
  if( camera == C_LIBRE)
  {
    cameraLibre->translation(GAUCHE,cameraLibre->pas);
  }
  else
  {
    cameraPolaire->translation(GAUCHE,cameraPolaire->pas);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonTransUpClick(TObject *Sender)
{
  if( camera == C_LIBRE)
  {
    cameraLibre->translation(HAUT,cameraLibre->pas);
  }
  else
  {
    cameraPolaire->translation(HAUT,cameraPolaire->pas);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonTransDownClick(TObject *Sender)
{
  if( camera == C_LIBRE)
  {
    cameraLibre->translation(BAS,cameraLibre->pas);
  }
  else
  {
    cameraPolaire->translation(BAS,cameraPolaire->pas);
  }
}
//---------------------------------------------------------------------------



void __fastcall TForm1::ButtonStopClick(TObject *Sender)
{
        if(CalculPaveThread!=NULL)
        {
                CalculPaveThread->Resume();

                CalculPaveThread->Terminate();
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBoxRenduRougeChange(TObject *Sender)
{
 renduRouge = (TYPE_RENDU) ComboBoxRenduRouge->Items->Objects[ComboBoxRenduRouge->ItemIndex];
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBoxResolutionChange(TObject *Sender)
{
 methodeResolution = (TYPE_RESOLUTION) ComboBoxResolution->Items->Objects[ComboBoxResolution->ItemIndex];
}
//---------------------------------------------------------------------------



void __fastcall TForm1::CheckBoxPRougeClick(TObject *Sender)
{
   optionAffichage.affPavetRouge = (CheckBoxPRouge->State==cbChecked);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBoxPBleuClick(TObject *Sender)
{
   optionAffichage.affPavetBleu = (CheckBoxPBleu->State==cbChecked);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBoxPVertClick(TObject *Sender)
{
   optionAffichage.affPavetVert = (CheckBoxPVert->State==cbChecked);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBoxTransClick(TObject *Sender)
{
   optionAffichage.transparence = (CheckBoxTrans->State==cbChecked);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ComboBoxTypeCameraChange(TObject *Sender)
{
   camera = (TYPE_CAMERA) ComboBoxTypeCamera->Items->Objects[ComboBoxTypeCamera->ItemIndex];
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBoxRenduVertChange(TObject *Sender)
{
 renduVert = (TYPE_RENDU) ComboBoxRenduVert->Items->Objects[ComboBoxRenduVert->ItemIndex];
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBoxRenduBleuChange(TObject *Sender)
{
   renduBleu = (TYPE_RENDU) ComboBoxRenduBleu->Items->Objects[ComboBoxRenduBleu->ItemIndex];        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonResetCameraClick(TObject *Sender)
{
  zoom = 1.0;
  if( camera == C_LIBRE)
  {
    cameraLibre->pos = Point3d(0,0,-10);
    cameraLibre->modele_inverse( Point3d(0,0,1) );//on regarde vers les Z positif
    cameraLibre->update_camera();
  }
  else
  {
    cameraPolaire->pos = Point3d(0,0,-10);
    cameraPolaire->modele_inverse( Point3d(0,0,1) );//on regarde vers les Z positif
    cameraPolaire->update_camera();
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::tpsMiseAjourChange(TObject *Sender)
{
Form1->updateText();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::precisionChange(TObject *Sender)
{
Form1->updateText();
}
//-------------------------------------------------------------------------- _
void __fastcall TForm1::echantillonClick(TObject *Sender)
{
  char temp[255];

  if(CalculPave::fin==true)
  {
        Form1->OpenFile->Options.Clear();
        Form1->OpenFile->Options<<ofFileMustExist;
        Form1->OpenFile->Filter = "Fichiers texte (*.txt)|*.txt|All files (*.*)|*.*";
        Form1->OpenFile->FilterIndex = 1; // dmarre la bote de dialogue montrant tout les fichiers texts
        if (Form1->OpenFile->Execute())
        {
                _echantillon.putNameFileEchantillon(Form1->OpenFile->Files->Strings[0].c_str());
                _echantillon.getNameFileEchantillon(temp);
                Form1->F_echantillons->Text = temp;
                _echantillon.loadFile();
        }
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OptionFichierClick(TObject *Sender)
{
        _echantillon.show();        
}


//---------------------------------------------------------------------------
void __fastcall TForm1::SaveClick(TObject *Sender)
{
        if (SaveDialog2->Execute())
        {
                if(CalculPave::fin==true)
                {
                        if(CalculPaveThread!=NULL)
                        {
                                CalculPaveThread->save(SaveDialog2->Files->Strings[0].c_str());
                        }
                }
        }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::loadProblemeClick(TObject *Sender)
{
  char temp[255];

  if(CalculPave::fin==true)
  {
        Form1->OpenFile->Options.Clear();
        Form1->OpenFile->Options<<ofFileMustExist;
        Form1->OpenFile->Filter = "Fichiers probleme (*.pbm)|*.pbm";
        Form1->OpenFile->FilterIndex = 1; // dmarre la bote de dialogue montrant tout les fichiers
        if (Form1->OpenFile->Execute())
        {
                strcpy(temp,Form1->OpenFile->Files->Strings[0].c_str());
                if(probleme.load(temp))
                {
                        Form1->fichierPbm->Text = Form1->OpenFile->Files->Strings[0].c_str();
                        ShowMessage(AnsiString("Fichier probleme charg !!"));
                }
                else
                {
                        ShowMessage(AnsiString("Erreur chargement fichier\n consultez le fichier error.txt"));        
                }
        }
  }
}
//---------------------------------------------------------------------------




void __fastcall TForm1::alphaCoupeChange(TObject *Sender)
{
  initCoupure();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::lCoupureChange(TObject *Sender)
{
  initCoupure();
}
//---------------------------------------------------------------------------

