#ifndef MATRICE_H
#define MATRICE_H

#include "Point3d.h"
#include "Vecteur.h"
#define NMAX 5
#define N2MAX 2*NMAX-1

class Matrice
{
	private:
		double mat[4][4];

	public:
		friend int Invers(double* a,double *b,int
		n);
		Matrice inverse();
		Matrice();
		Matrice(double tab[16]);
		Matrice(Matrice const &m);

		void set(int l, int c, double a);
		double get(int l, int c);

		static Matrice produitMatrice(Matrice m1, Matrice m2);
		static Vecteur image(Matrice m, Vecteur v);

		static Matrice identite(void);
		static Matrice rotationX(double c, double s);
		static Matrice rotationY(double c, double s);
		static Matrice rotationZ(double c, double s);
		static Matrice rotationU(double c, double s, Vecteur u);
		static Matrice calculMatriceHomogene(Point3d pos, Vecteur u, Vecteur v);
		static Matrice calculMatriceHomogeneInverse(Point3d, Vecteur,Vecteur);
		
		static void calculRotationCS(double & c1,double & s1,
			double & c2,double & s2,
			double & c3,double & s3,
			Vecteur u,Vecteur v);
			
		static void calculRotation(double &o1,double &o2,double &o3,
			Vecteur u,Vecteur v);
			
		static void calculVecteur(double o1,double o2,double o3,
			Vecteur &,Vecteur &, Vecteur&);
		
		void toTab(float *);
		void toMat(float *tab);

		void affiche();
		
		friend bool nonNul(double d);
};
#endif
