// Type.cpp: implementation of the Type class.
//
//////////////////////////////////////////////////////////////////////

#include "Type.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Type::Type()
{

}

Type::~Type()
{

}

bool Type::isBoolean(void)
{
	switch(type)
	{
		case INTERVAL:
			return false;
		case _BOOLEAN:
			return true;
	}

	return false;
}

bool Type::isInterval(void)
{
	switch(type)
	{
		case _BOOLEAN:
			return false;
		case INTERVAL:
			return true;
	}

	return false;
}

interval Type::getInterval(void) const
{
	return inter;
}

iboolean Type::getBoolean(void) const
{
	return boolean;
}

Type::Type(interval _inter)
{
	inter = _inter;

    type = INTERVAL;
}

Type::Type(iboolean _bool)
{
	boolean = _bool;
	
	type = _BOOLEAN;
	
}

Type::Type(const Type &t)
{
	this->boolean	=	t.boolean;
	this->inter		=	t.inter;
	this->type		=	t.type;
}

ostream& operator<< (ostream& os, const Type& a)
{
	switch(a.type)
	{
		case INTERVAL:
			os<<a.getInterval();
		break;
		case _BOOLEAN:
		{
			iboolean b = a.getBoolean();
			if(b==itrue)
				os<<"Vrai";
			
			if(b==ifalse)
				os<<"faux";
			
			if(b==iperhaps)
				os<<"Vrai/Faux";
			
			if(b==empty)
				os<<"Vide";
		}
		break;
	}
	
    return os;
}


Type::Type(double val)
{
	*this = Type(interval(val));
}

Type::Type(int val)
{
	*this = Type(interval(val));
}

Type::Type(float val)
{
	*this = Type(interval(val));
}

Type::Type(bool val)
{
	*this = Type(iboolean(val));
}
