// Vecteur.h: interface for the Vecteur class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _VECTEUR
#define _VECTEUR

#include <math.h>

class Vecteur  
{
public:
	void normaliser();
	Vecteur(float* pt1, float* pt2);
	double angle(Vecteur v);
	double norm(void);
	void toFloat(float *tab);

	Vecteur(double dx,double dy,double dz);
	
	Vecteur(double tab[3]);
	Vecteur(const Vecteur & vect);
	
	double dx;
	double dy;
	double dz;
	double dw;
	
	double get(int i);
	void set(int i,double d);

	bool operator<(Vecteur v);
	bool operator==(Vecteur v);
	void operator*=(float coeff);
	void operator/=(float coeff);
	void operator+=(Vecteur v);
	
	double operator*(Vecteur vect);
	Vecteur operator*(float coeff);
	Vecteur prodVectoriel(Vecteur a);
	
	static Vecteur prodVectoriel(Vecteur a, Vecteur b);
	
	static double cosinus(Vecteur u, Vecteur v);
	static double sinus(Vecteur u, Vecteur v, Vecteur w);
	Vecteur projeteXY(void);
	Vecteur projeteXZ(void);
	Vecteur projeteYZ(void);

	void affiche();

	Vecteur();
	virtual ~Vecteur();
};

#endif
