// amera.cpp: implementation of the Camera class.
//
//////////////////////////////////////////////////////////////////////

#include "amera.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

double Camera::pisur180 = PI/180;

Camera::Camera()
{
	this->aglxz = 0.0;
	this->aglyz = 0.0;
        this->pas = 0.0;
}

Camera::Camera(const Camera &cam)
{
	this->aglxz = cam.aglxz;
	this->aglyz = cam.aglyz;
	this->dir   = cam.dir;
	this->pos   = cam.pos;
	this->targ  = cam.targ;
}

Camera::~Camera()
{

}

//////////////////////////////////////////////////////////////////////
// Mthodes
//////////////////////////////////////////////////////////////////////

void Camera::update_camera()
{
	double tmp1;
	double tmp2;
	double tmp3;
	double tmp4;

	double ag1 = (double)(aglyz*pisur180);
	double ag2 = (double)(aglxz*pisur180);


	tmp1 = cos(ag1);
	tmp2 = sin(ag1);
	
	tmp3 = cos(ag2);
	tmp4 = sin(ag2);

	

	dir.dx=tmp1 * tmp3;
	dir.dz=tmp1 * tmp4;
	dir.dy=tmp2;

	targ.x = (float)(pos.x + dir.dx);
	targ.y = (float)(pos.y + dir.dy);
	targ.z = (float)(pos.z + dir.dz);
}


void Camera::modele_inverse(Point3d pt)
{
	double sinB;
	double B;
	double A;

	pt.normalize();

	A = asin(pt.y);
	sinB = pt.z/(cos(A));

	B = asin(sinB);

	if(B == 0 && pt.x<0)
		B = PI;


	aglyz = A / pisur180;
	aglxz = B / pisur180;
}


void Camera::toScreen()
{
//	gluLookAt(pos.x,pos.y,pos.z,targ.x,targ.y,targ.z,0.0,1.0,0.0);
}

bool Camera::operator <(Camera cam)
{
	cam = cam;	// pour retirer le warning
	return false;
}

bool Camera::operator ==(Camera cam)
{
	return (this->aglxz == cam.aglxz		&&
			this->aglyz == cam.aglyz	&&
			this->dir	== cam.dir	&&
			this->pos	== cam.pos	&&
			this->targ	== cam.targ);
}

void Camera::rotatexz(float agl)
{
	if(agl!=0)
	{
		aglxz+=agl;
		/*if(aglxz>360)
			aglxz-=360;
		if(aglxz<0)
			aglxz=360+aglxz;*/

		update_camera();
	}
}

void Camera::rotateyz(float agl)
{
	if( agl!=0 && aglyz+agl>-90 && aglyz+agl<90)
	{
		aglyz+=agl;
		update_camera();
	}
}


void Camera::avance(float vitesse)
{
	Vecteur v;

	v = this->dir;

	v*=vitesse;

	this->pos	+= v;
	this->targ	+= v;
}

bool Camera::translation(MVT_CAM mvt,float vitesse)
{
	Vecteur v;
	Vecteur tmp;

	switch(mvt)
	{
		case HAUT:
			v = Vecteur(0,1,0);
			v.normaliser();
		break;

		case BAS :
			v = Vecteur(0,-1,0);
			v.normaliser();
		break;

		case GAUCHE:
			tmp = dir;
			tmp.dy = 0;
			v = Matrice::image((Matrice::rotationY(0,1)),tmp);
			v.dy = 0;
			v.normaliser();
		break;
		case DROITE:
			tmp = dir;
			tmp.dy = 0;
			v = Matrice::image((Matrice::rotationY(0,-1)),tmp);
			v.dy = 0;
			v.normaliser();
		break;
	}

	v*=vitesse;

	tmp = v;
	
	this->pos+=v;
	this->targ+=v;
	
	return true;
}
