#include "pavet3d.h"


pave3d::pave3d()
{
        this->X = interval(0,0);
        this->Y = interval(0,0);
        this->Z = interval(0,0);

        this->rouge = 0.0f;
        this->vert  = 0.0f;
        this->bleu = 0.0f;
}

pave3d::pave3d(const pave3d& pave)
{
        this->rouge = pave.rouge;
        this->vert = pave.vert;
        this->bleu = pave.bleu;

        this->X = pave.X;
        this->Y = pave.Y;
        this->Z = pave.Z;
}

pave3d::pave3d(interval x,interval y,interval z,float r,float g,float b)
{
        this->X = x;
        this->Y = y;
        this->Z = z;
        this->rouge = r;
        this->vert = g;
        this->bleu = b;
}
pave3d::pave3d(box _box,float r,float g,float b)
{
        this->X = interval(0,0);
        this->Y = interval(0,0);
        this->Z = interval(0,0);
        switch(_box.dim)
        {
                case 1:
                        X = _box[1];
                break;
                case 2:
                        X = _box[1];
                        Y = _box[2];
                break;
                case 3:
                        X = _box[1];
                        Y = _box[2];
                        Z = _box[3];
                break;
        }
        this->rouge = r;
        this->vert = g;
        this->bleu = b;
}

void pave3d::drawPave3d(TYPE_RENDU rendu,float alpha)
{
 double p1_x,p1_y,p1_z;
 double p2_x,p2_y,p2_z;
 double p3_x,p3_y,p3_z;
 double p4_x,p4_y,p4_z;

 double p5_x,p5_y,p5_z;
 double p6_x,p6_y,p6_z;
 double p7_x,p7_y,p7_z;
 double p8_x,p8_y,p8_z;

 p1_x = X.GetInf();
 p1_y = Y.GetInf();
 p1_z = Z.GetInf();

 p2_x = X.GetSup();
 p2_y = Y.GetInf();
 p2_z = Z.GetInf();

 p3_x = X.GetSup();
 p3_y = Y.GetInf();
 p3_z = Z.GetSup();

 p4_x = X.GetInf();
 p4_y = Y.GetInf();
 p4_z = Z.GetSup();

 p5_x = X.GetInf();
 p5_y = Y.GetSup();
 p5_z = Z.GetInf();

 p6_x = X.GetSup();
 p6_y = Y.GetSup();
 p6_z = Z.GetInf();

 p7_x = X.GetSup();
 p7_y = Y.GetSup();
 p7_z = Z.GetSup();

 p8_x = X.GetInf();
 p8_y = Y.GetSup();
 p8_z = Z.GetSup();


 glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT);
 glColor4f(rouge,vert,bleu,alpha);
 glColorMaterial(GL_FRONT_AND_BACK, GL_DIFFUSE);
 glColor4f(rouge,vert,bleu,alpha);
 glColorMaterial(GL_FRONT_AND_BACK, GL_SPECULAR);
 glColor4f(rouge,vert,bleu,alpha);

 if(rendu == WIREFRAME)
 {
 glBegin(GL_LINE_LOOP);
 //face 1 2 3 4
    glNormal3f( 0.0f , -1.0f , 0.0f );
    glVertex3d(  p1_x , p1_y , p1_z);
    glVertex3d(  p2_x , p2_y , p2_z);
    glVertex3d(  p3_x , p3_y , p3_z);
    glVertex3d(  p4_x , p4_y , p4_z);
    glVertex3d(  p1_x , p1_y , p1_z);
 glEnd();

 glBegin(GL_LINE_LOOP);
 //face 5 8 7 6
    glNormal3f( 0.0f , 1.0f , 0.0f );
    glVertex3d(  p5_x , p5_y , p5_z);
    glVertex3d(  p8_x , p8_y , p8_z);
    glVertex3d(  p7_x , p7_y , p7_z);
    glVertex3d(  p6_x , p6_y , p6_z);
    glVertex3d(  p5_x , p5_y , p5_z);
 glEnd();

 glBegin(GL_LINE_LOOP);
 //face 1 5 6 2
    glNormal3f( 0.0f , 0.0f , 1.0f );
    glVertex3d(  p1_x , p1_y , p1_z);
    glVertex3d(  p5_x , p5_y , p5_z);
    glVertex3d(  p6_x , p6_y , p6_z);
    glVertex3d(  p2_x , p2_y , p2_z);
    glVertex3d(  p1_x , p1_y , p1_z);
 glEnd();

 glBegin(GL_LINE_LOOP);
 //face 4 3 7 8
    glNormal3f( 0.0f , 0.0f , -1.0f );
    glVertex3d(  p4_x , p4_y , p4_z);
    glVertex3d(  p3_x , p3_y , p3_z);
    glVertex3d(  p7_x , p7_y , p7_z);
    glVertex3d(  p8_x , p8_y , p8_z);
    glVertex3d(  p4_x , p4_y , p4_z);
 glEnd();

 glBegin(GL_LINE_LOOP);
 //face 2 6 7 3
    glNormal3f( 1.0f , 0.0f , 0.0f );
    glVertex3d(  p2_x , p2_y , p2_z);
    glVertex3d(  p6_x , p6_y , p6_z);
    glVertex3d(  p7_x , p7_y , p7_z);
    glVertex3d(  p3_x , p3_y , p3_z);
    glVertex3d(  p2_x , p2_y , p2_z);
 glEnd();

 glBegin(GL_LINE_LOOP);
 //face 4 8 5 1
    glNormal3f( -1.0f , 0.0f , 0.0f );
    glVertex3d(  p4_x , p4_y , p4_z);
    glVertex3d(  p8_x , p8_y , p8_z);
    glVertex3d(  p5_x , p5_y , p5_z);
    glVertex3d(  p1_x , p1_y , p1_z);
    glVertex3d(  p4_x , p4_y , p4_z);
 glEnd();
 }

 if(rendu == SOLID)
 {
 glBegin(GL_QUADS);
 //face 1 2 3 4
    glNormal3f( 0.0f , -1.0f , 0.0f );
    glVertex3d(  p1_x , p1_y , p1_z);
    glVertex3d(  p2_x , p2_y , p2_z);
    glVertex3d(  p3_x , p3_y , p3_z);
    glVertex3d(  p4_x , p4_y , p4_z);

 //face 5 8 7 6
    glNormal3f( 0.0f , 1.0f , 0.0f );
    glVertex3d(  p5_x , p5_y , p5_z);
    glVertex3d(  p8_x , p8_y , p8_z);
    glVertex3d(  p7_x , p7_y , p7_z);
    glVertex3d(  p6_x , p6_y , p6_z);

 //face 1 5 6 2
    glNormal3f( 0.0f , 0.0f , 1.0f );
    glVertex3d(  p1_x , p1_y , p1_z);
    glVertex3d(  p5_x , p5_y , p5_z);
    glVertex3d(  p6_x , p6_y , p6_z);
    glVertex3d(  p2_x , p2_y , p2_z);

 //face 4 3 7 8
    glNormal3f( 0.0f , 0.0f , -1.0f );
    glVertex3d(  p4_x , p4_y , p4_z);
    glVertex3d(  p3_x , p3_y , p3_z);
    glVertex3d(  p7_x , p7_y , p7_z);
    glVertex3d(  p8_x , p8_y , p8_z);

 //face 2 6 7 3
    glNormal3f( 1.0f , 0.0f , 0.0f );
    glVertex3d(  p2_x , p2_y , p2_z);
    glVertex3d(  p6_x , p6_y , p6_z);
    glVertex3d(  p7_x , p7_y , p7_z);
    glVertex3d(  p3_x , p3_y , p3_z);

 //face 4 8 5 1
    glNormal3f( -1.0f , 0.0f , 0.0f );
    glVertex3d(  p4_x , p4_y , p4_z);
    glVertex3d(  p8_x , p8_y , p8_z);
    glVertex3d(  p5_x , p5_y , p5_z);
    glVertex3d(  p1_x , p1_y , p1_z);
glEnd();
 }
}
